var
long cmd_val, param1z, param2z, retval3 
byte count

pub start | tmp, i
cognew(@entry, @cmd_val)       'start a memory cog
send_cmd(1, count, 0, 0)       'send the start command(command, cog, parameter 1, parameter 2)
return count++                 'return the reference value, and increment the count

pub stop(ref)
send_cmd(2, ref, 0, 0)

pub read(cog_addr, ref)
return send_cmd(3, ref, cog_addr, 0) & $FF 

pub block_read(cog_addr, data_addr, num, ref)
retval3 := num
return send_cmd(4, ref, cog_addr, data_addr)

pub write(cog_addr, data, ref)
return send_cmd(5, ref, cog_addr, data)

pub block_write(cog_addr, data_addr, num, ref)
retval3 := num
return send_cmd(6, ref, cog_addr, data_addr)

pri send_cmd(comd, cog, pa1, pa2)   'send command
param1z := pa1                      'set the appropriate values
param2z := pa2
cmd_val := comd << 3 | cog          'the first 3 bits are the ID number, the rest, the command
repeat until cmd_val == 0           'wait until command is completed
return retval3                      'return the return value

dat
org
entry
              jmp #init_data         'initialize the system
init_data_return
              mov zero, #0           'set zero to zero
              wrlong zero, cmd       'signal completion of command
main
              rdlong inst, cmd
              mov temp2, inst
              and temp2, #%111
              cmp temp2, cognum  wz
        if_nz jmp #main
              shr inst, #3
:maine
              cmp inst, #2      wz
        if_z  jmp #stp
              cmp inst, #3      wz
        if_z  call #read_data
              cmp inst, #4      wz
        if_z  call #bread_data
              cmp inst, #5      wz
        if_z  call #write_data
              cmp inst, #6      wz
        if_z  call #bwrite_data
              cmp inst, #0      wz
        if_nz wrlong zero, cmd
              jmp #main

stp
              cogid temp
              wrlong zero, cmd
              cogstop temp

read_data
              rdlong temp, p1
              mov temp2, temp
              shr temp, #2
              and temp2, #3
              add temp, #mem
              movs _inst, temp 
              shl temp2, #3
_inst         mov temp3, 0-0
              shr temp3, temp2 
              wrlong temp3, retval
read_data_ret
              ret

bread_data
              rdlong temp, p1
              rdlong temp4, p2
              rdlong idx, retval
lewp
              mov temp2, temp
              shr temp, #2
              add temp, #mem
              and temp2, #3
              movs _instr_, temp
              shl temp2, #3
_instr_       mov temp3, 0-0
              shr temp3, temp2
              wrbyte temp3, temp4
              add temp4, #1
              shl temp, #2
              shr temp2, #3
              or temp, temp2
              add temp, #1
              sub temp, #mem    
              djnz idx, #lewp
              
bread_data_ret
              ret

bwrite_data
              rdlong temp, p1
              rdlong zero, p2
              rdlong idx, retval
looop                           
              mov temp2, temp
              shr temp, #2
              and temp2, #3
              shl temp2, #3
              add temp, #mem
              mov mask, #$FF
              movs __instr, temp
              shl mask, temp2
__instr       mov temp3, 0-0
              andn temp3, mask
              rdlong temp4, zero
              shl temp4, temp2
              and temp4, mask
              movd instr__, temp
              or temp3, temp4
instr__       mov 0-0, temp3
              sub temp, #mem
              add zero, #1
              shl temp, #2
              shr temp2, #3
              or temp, temp2
              add temp, #1
              djnz idx, #looop
              mov zero, #0
bwrite_data_ret
              ret        

write_data
              rdlong temp, p1
              mov temp2, temp
              shr temp, #2
              and temp2, #3
              shl temp2, #3
              add temp, #mem
              mov mask, #$FF
              movs _instr, temp
              shl mask, temp2
_instr        mov temp3, 0-0
              andn temp3, mask
              rdlong temp4, p2
              shl temp4, temp2
              and temp4, mask
              movd instr_, temp
              or temp3, temp4
instr_        mov 0-0, temp3
write_data_ret
              ret



cognum long 0
zero long 0
cmd long 0
p1 long 0
p2 long 0
retval long 0
temp mov zero, #$1EF - mem      {{these instructions erase the memory. they are located here to save space because they are in variables which get overwritten}}
temp2 add zero, #mem
temp3 movd mask, zero
temp4 sub zero, #mem 
mask mov 0-0, #0
idx  djnz zero, #temp2
inst jmp #init_data_return
mem long 0
{{all these instructions get erased because they are only needed once}}
init_data
              mov zero, par  'set all the addresses   
              mov cmd, zero
              add zero, #4
              mov p1, zero
              add zero, #4  
              mov p2, zero
              add zero, #4
              mov retval, zero
init_data_2
              rdlong zero, cmd        'wait for the start command
              mov mem, zero
              and zero, #1<<3         'isolate the command data
              cmp zero, #1<<3         wz    'check if right
        if_nz jmp #init_data_2
              and mem, #%111                'get the id number
              mov cognum, mem               'store for future reference
              jmp #temp                     'start the memory erase procedure
              